##
## Deal with audio issues.  At present, this is just 
## volume.
##
package POE::Jukebox::AudioManager;
use strict;
use Audio::Mixer;
use POE;

sub new
{
	my $self = shift;
	my @list = @_;
	
	POE::Session->create(
		args => [ @list ],
		inline_states => {
			_start => \&_start,
			_stop => \&_stop,
			volume => \&volume,
		},
	);
}

sub _start
{
	print "Starting Audio Manager\n";
	$_[KERNEL]->alias_set( 'audiomanager' );
	print "Started Audio Manager\n";
}

sub _stop
{
	delete $_[HEAP]->{self};
	print "Stopped Audio Manager\n";
}


sub volume
{
	my $session = $_[ARG0];
	my $left_vol = $_[ARG1];
	my $right_vol = $_[ARG2];

	if(!defined($left_vol)) {
		$_[KERNEL]->post($session,'out_to_client',"ERR No volume given");
		return;
	}
	if(!defined($right_vol)) {
		$right_vol = $left_vol;
	}
	if(Audio::Mixer::set_cval('vol',$left_vol,$right_vol)) {
		$_[KERNEL]->post($session,'out_to_client',"ERR Audio::Mixer error setting volume");
		return;
	}
	$_[KERNEL]->post('playlist','send_current_info');
}

1;
