use strict;
package POE::Jukebox::TcpServer;

use POE;
use POE::Component::Server::TCP;
use POE::Jukebox::TcpConnection;
use Socket;

sub new
{
	my $class = shift;
	my $self = bless({}, $class);
	
	my %data = @_;

	POE::Component::Server::TCP->new(
		Port => $data{Port} || 1234,
		Address => $data{Address} || undef,
		Alias => 'server',
		Acceptor => \&accept_handler,
		Error => \&error_handler,
	);

	print "Created TcpServer\n";
}

sub accept_handler
{
	my($socket, $peer_addr, $peer_port, $wheel_id) = @_[ARG0, ARG1, ARG2, ARG3];
	print "Got client ", inet_ntoa($peer_addr), " with remote port $peer_port\n";
	POE::Jukebox::TcpConnection->new($socket, inet_ntoa($peer_addr), $wheel_id);
}

sub error_handler
{
	my ($operation, $errnum, $errstr, $wheel_id) = @_[ARG0, ARG1, ARG2, ARG3];
	print "Got error: $operation $errnum: $errstr\n";
	delete $_[HEAP]->{wheels}->{$wheel_id};
}

1;
